<template>
    <teleport
        to="body"
    >
        <div
            class="fixed top-0 left-0 right-0 bottom-0 w-screen h-screen bg-gray-700 bg-opacity-40 flex justify-center text-center items-center"
        >
            <div
                class="w-[360px] bg-neutral rounded-lg p-4 mx-auto"
            >
                <div
                    class="my-6 text-center mx-auto text-lg font-bold"
                >
                    {{ computedPassword2VerifyTitle }}
                </div>
                <div
                    class="text-center mx-auto px-9 mb-4"
                >
                    {{ computedPassword2VerifyMessage }}
                </div>
                <div>
                    <form-pin
                        v-model="password2"
                        name="current_password2"
                        :errors="errors"
                        :hide-label="true"
                        :dark="true"
                        size="lg"
                        @update:model-value="newValue => password2 = newValue"
                    />
                </div>
                <div class="mt-6 text-2xl uppercase">
                    <auto-button
                        :busy="busy"
                        :rounded="false"
                        @click="submitForm"
                    >
                        {{ $t('confirm') }}
                    </auto-button>
                </div>
                <div class="mt-4 mb-6 text-xl capitalize">
                    <a
                        href="javascript:"
                        class="underline"
                        @click="close"
                    >
                        {{ $t('close') }}
                    </a>
                </div>
            </div>
        </div>
    </teleport>
</template>

<script setup>
import {ref, computed, inject} from "vue";
import {useI18n} from "vue-i18n";
import AutoButton from "~/components/button/auto-button.vue";
import FormPin from "~/components/form/form-pin.vue";

const props = defineProps({
    password2VerifyTitle: {
        required: false,
        type: String,
        default: 'default',
    },
    password2VerifyMessage: {
        required: false,
        type: String,
        default: 'default',
    },
    errors: {
        required: false,
        type: Array,
        default: null,
    }
});
const emit = defineEmits(['confirm', 'close']);

const busy = ref(false);
const password2 = ref('');
const i18n = useI18n();

const computedPassword2VerifyTitle = computed(() => {
    return props.password2VerifyTitle === 'default' ? i18n.t('password2_verify_default_title') : props.password2VerifyTitle;
});
const computedPassword2VerifyMessage = computed(() => {
    return props.password2VerifyMessage === 'default' ? i18n.t('password2_to_authorize') : props.password2VerifyMessage;
});

const submitForm = async () => {
    emit('confirm', password2.value);
};

const close = async () => {
    emit('close');
};
</script>
